diff -Nraup linux-2.6.14_mm1/arch/ia64/kernel/kprobes.c linux-2.6.14_mm1_jprobe/arch/ia64/kernel/kprobes.c
--- linux-2.6.14_mm1/arch/ia64/kernel/kprobes.c	2005-11-09 19:08:51.000000000 +0800
+++ linux-2.6.14_mm1_jprobe/arch/ia64/kernel/kprobes.c	2005-11-24 16:24:07.000000000 +0800
@@ -764,9 +764,15 @@ int __kprobes setjmp_pre_handler(struct 
 	struct jprobe *jp = container_of(p, struct jprobe, kp);
 	unsigned long addr = ((struct fnptr *)(jp->entry))->ip;
 	struct kprobe_ctlblk *kcb = get_kprobe_ctlblk();
+	unsigned long *ar_bsp = (unsigned long *)*((unsigned long *)regs - 2);
+	int param_num = regs->cr_ifs & 0x3f;
 
 	/* save architectural state */
 	kcb->jprobe_saved_regs = *regs;
+	asm volatile("{\n\tflushrs\n\t\n\t\n\t}":::"memory");
+	memcpy( kcb->jprobes_saved_stacked_regs,
+		ia64_rse_skip_regs(ar_bsp, -param_num),
+		REAL_PARAM_RSE_SIZE(regs)*sizeof(unsigned long) );
 
 	/* after rfi, execute the jprobe instrumented function */
 	regs->cr_iip = addr & ~0xFULL;
@@ -785,8 +791,21 @@ int __kprobes setjmp_pre_handler(struct 
 int __kprobes longjmp_break_handler(struct kprobe *p, struct pt_regs *regs)
 {
 	struct kprobe_ctlblk *kcb = get_kprobe_ctlblk();
+	unsigned long *ar_bsp = (unsigned long *)*((unsigned long *)regs - 2);
+	int param_num = regs->cr_ifs & 0x3f;
+	unsigned long rsc_save = 0;
 
 	*regs = kcb->jprobe_saved_regs;
+	asm volatile("{\n\tflushrs\n\t\n\t\n\t}":::"memory");
+	memcpy(	ia64_rse_skip_regs(ar_bsp, -param_num),
+		kcb->jprobes_saved_stacked_regs,
+		REAL_PARAM_RSE_SIZE(regs)*sizeof(unsigned long) );
+	asm volatile( "mov %0=ar.rsc;;\n\t"
+			"mov ar.rsc=0;;\n\t"
+			"{\n\tloadrs;;\n\t\n\t\n\t}\n\t"
+			"mov ar.rsc=%1\n\t"
+			:"=r" (rsc_save):"r" (rsc_save):"memory");
+
 	preempt_enable_no_resched();
 	return 1;
 }
diff -Nraup linux-2.6.14_mm1/include/asm-ia64/kprobes.h linux-2.6.14_mm1_jprobe/include/asm-ia64/kprobes.h
--- linux-2.6.14_mm1/include/asm-ia64/kprobes.h	2005-11-09 19:08:43.000000000 +0800
+++ linux-2.6.14_mm1_jprobe/include/asm-ia64/kprobes.h	2005-11-23 23:36:30.000000000 +0800
@@ -68,10 +68,19 @@ struct prev_kprobe {
 	unsigned long status;
 };
 
+#define	MAX_PARAM_RSE_SIZE	(0x80+0x80/0x3f)
+#define REAL_PARAM_RSE_SIZE(regs)	({	\
+			unsigned long *ar_bsp;					\
+			int param_num = regs->cr_ifs & 0x3f;			\
+			ar_bsp = (unsigned long *)*((unsigned long *)regs - 2);	\
+			ar_bsp - ia64_rse_skip_regs(ar_bsp, -param_num);	\
+		})
+
 /* per-cpu kprobe control block */
 struct kprobe_ctlblk {
 	unsigned long kprobe_status;
 	struct pt_regs jprobe_saved_regs;
+	unsigned long jprobes_saved_stacked_regs[MAX_PARAM_RSE_SIZE];
 	struct prev_kprobe prev_kprobe;
 };
 
